package com.novastar.sdkdemo;

import android.app.Activity;
import android.content.Context;
import android.os.Handler;
import android.os.Message;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;
import com.sun.jna.Native;
import com.sun.jna.Pointer;

public class MainActivity extends Activity {

    int m_code;
    Pointer m_data;
    String createProgram;
    String editProgram;
    String genrateProgram;
    String trasfromProgram;

    ViplexCore instance = (ViplexCore) Native.loadLibrary("viplexcore",ViplexCore.class);

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        if (isGrantSDCardReadPermission()) {
            //
        } else {
            requestPermission();
        }

        createProgram = "{\"name\":\"Demo\",\"width\":500,\"height\":500,\"tplID\":1,\"winInfo\":{\"height\":100,\"width\":100,\"left\":0,\"top\":0,\"zindex\":0,\"index\":0}}";
        editProgram = "{\"programID\":1,\"pageID\":1,\"pageInfo\":{\"name\":\"jiemu\",\"widgetContainers\":[{\"audioGroup\":\"\",\"backgroundColor\":\"#00000000\",\"backgroundDrawable\":\"\",\"contents\":{\"widgetGroups\":[],\"widgets\":[{\"id\":1,\"enable\":true,\"repeatCount\":1,\"layout\":{\"y\":\"0\",\"height\":\"100%\",\"x\":\"0\",\"width\":\"100%\"},\"backgroundColor\":\"#00000000\",\"backgroundDrawable\":\"\",\"backgroundMusic\":\"\",\"zOrder\":0,\"displayRatio\":\"FULL\",\"outAnimation\":{\"type\":0,\"duration\":0},\"dataSource\":\"a107566dc8d5f2c18ffa4ea03f86c1cd.png\",\"type\":\"PICTURE\",\"constraints\":[{\"cron\":[],\"endTime\":\"4017-12-30T23:59:59Z+8:00\",\"startTime\":\"1970-01-01T00:00:00Z+8:00\"}],\"border\":{\"borderThickness\":\"2px,3px,5%,6\",\"style\":0,\"backgroundColor\":\"#ff000000\",\"name\":\"border\",\"cornerRadius\":\"2%\",\"effects\":{\"headTailSpacing\":\"\",\"isHeadTail\":false,\"speedByPixelEnable\":true,\"speed\":0,\"animation\":\"CLOCK_WISE\"}},\"inAnimation\":{\"type\":0,\"duration\":1000},\"duration\":3605000,\"name\":\"4.png\",\"originalDataSource\":\""+ getDiskCacheDir(MainActivity.this) + "/4.png\",\"functionStorage\":\"\",\"isSupportSpecialEffects\":false}]},\"enable\":true,\"id\":1,\"itemsSource\":\"\",\"layout\":{\"height\":\"1.0\",\"width\":\"1.0\",\"x\":\"0.0\",\"y\":\"0.0\"},\"name\":\"widgetContainers1\",\"pickCount\":0,\"pickPolicy\":\"ORDER\",\"zOrder\":0}]}}";
        genrateProgram = "{\"programID\":1,\"outPutPath\":\"" + getDiskCacheDir(MainActivity.this) + "\",\"mediasPath\":[{\"oldPath\":\"test\",\"newPath\":\"test\"}]}";
        trasfromProgram = "{\"sn\": \"BZSA79353N1310006847\",\"iconPath\": \"\",\"iconName\": \"\",\"sendProgramFilePaths\": {\"programPath\": \"" + getDiskCacheDir(MainActivity.this) +  "/program1\",\"mediasPath\": {\"" + getDiskCacheDir(MainActivity.this)+ "/4.png\"" + ":" + "\"4.png\"}},\"programName\": \"program1\",\"deviceIdentifier\": \"Demo\",\"startPlayAfterTransferred\": true,\"insertPlay\": true}";
		
		
		
		Boolean bTestVideo = false;
		if (bTestVideo)
		{
			editProgram = "{ \"programID\":1,\"pageID\":1,\"pageInfo\":{\"name\":\"Demo\",\"widgetContainers\":[{\"contents\":{\"widgets\":[{\"constraints\":[{\"cron\":[\"0 0 0 ? * 1,2,3,4,5,6,7\"],\"endTime\":\"4017-12-30T23:59:59Z 8:00\",\"startTime\":\"1970-01-01T00:00:00Z 8:00\"}],\"duration\":5000,\"dataSource\":\"219c7dd3260d6bf98ebf61b6da440ffd.avi\",\"type\":\"VIDEO\",\"name\":\"test.vai\",\"originalDataSource\":\""+ getDiskCacheDir(MainActivity.this) + "/test.avi\"}]},\"id\":1,\"name\":\"widgetContainers1\"}]}}";
			trasfromProgram = "{\"sn\": \"BZSA79353N1310006847\",\"iconPath\": \"\",\"iconName\": \"\",\"sendProgramFilePaths\": {\"programPath\": \"" + getDiskCacheDir(MainActivity.this) +  "/program1\",\"mediasPath\": {\"" + getDiskCacheDir(MainActivity.this)+ "/test.avi\"" + ":" + "\"test.avi\"}},\"programName\": \"program1\",\"deviceIdentifier\": \"Demo\",\"startPlayAfterTransferred\": true,\"insertPlay\": true}";
		}
        Button btnClick = findViewById(R.id.btn);
        Toast.makeText(MainActivity.this, "开始连接", Toast.LENGTH_SHORT).show();
        btnClick.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                String companyInfo = "{\"company\":\"NovaStar\",\"phone\":\"029-68216000\",\"email\":\"hr@novastar.tech\"}";
                instance.nvSetDevLang("Java");
                System.out.println("nvInit(sdk 初始化):");
                instance.nvInit(getDiskCacheDir(MainActivity.this),companyInfo);
                Log.e("QHT: path:", getDiskCacheDir(MainActivity.this));
                System.out.println("nvSerchTerminalAsync(sdk 搜索):");
                instance.nvSearchTerminalAsync(new ViplexCore.CallBack() {
                    @Override
                    public void dataCallBack(int code, String data) {
                        Log.e("QHT: 搜索:", data);
                        if (code == 0)
                        {
                            handler.sendEmptyMessage(0);
                        }
                    }
                });
            }
        });
    }

    public String getDiskCacheDir(Context context) {
        // adb push 4.png /storage/emulated/0/Android/data/com.novastar.sdkdemo/files/demotest
        String x = context.getExternalFilesDir("demotest").getAbsolutePath();
        return x;
    }

    private boolean isGrantSDCardReadPermission() {
        return PermissionUtils.isGrantSDCardReadPermission(this);
    }

    private void requestPermission() {
        PermissionUtils.requestSDCardReadPermission(this, REQUEST_CODE_SDCARD_READ);
    }

    private static final int REQUEST_CODE_SDCARD_READ = 1;

    @Override
    public void onRequestPermissionsResult(int requestCode,  String[] permissions,  int[] grantResults) {
        switch (requestCode) {
            case REQUEST_CODE_SDCARD_READ:
                if (isGrantSDCardReadPermission()) {
                    //
                } else {
                    Toast.makeText(this, "failure because without sd card read permission", Toast.LENGTH_SHORT).show();
                }
                break;

            default:
                break;
        }
    }

    private Handler handler = new Handler(){
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            switch (msg.what){
                case 0:
                    System.out.println("nvInit(sdk 登录):");
                    instance.nvLoginAsync("{\"sn\":\"BZSA79353N1310006847\",\"username\":\"admin\",\"rememberPwd\":1,\"password\":\"123456\",\"loginType\":0}",new ViplexCore.CallBack() {

                        @Override
                        public void dataCallBack(int code, String data) {
                            Log.e("QHT: 登录:", data);
                            handler.sendEmptyMessage(1);
                        }
                    });
                    break;
                case 1:
                System.out.println("ViplexCore Demo nvCreateProgramAsync(创建节目) begin... ");
                    instance.nvCreateProgramAsync(createProgram, new ViplexCore.CallBack() {

                        @Override
                        public void dataCallBack(int code, String data) {
                            Log.e("QHT: 创建节目:", data);
                            handler.sendEmptyMessage(2);
                        }
                    });
                    break;
                case 2:
                    System.out.println("ViplexCore Demo nvGetFileMD5Async(获取MD5) begin... ");
                    String requestDatapath = "{\"filePath\":\"" + getDiskCacheDir(MainActivity.this) + "/4.png\"}";
                    instance.nvGetFileMD5Async(requestDatapath,new ViplexCore.CallBack() {

                        @Override
                        public void dataCallBack(int code, String data) {
                            Log.e("QHT: 获取MD5:", data);
                            handler.sendEmptyMessage(3);
                        }
                    });
                    break;
                case 3:
                    System.out.println("ViplexCore Demo nvSetPageProgramAsync(编辑节目) begin... ");
                    instance.nvSetPageProgramAsync(editProgram,new ViplexCore.CallBack() {

                        @Override
                        public void dataCallBack(int code, String data) {
                            Log.e("QHT: 编辑节目:", data);
                            handler.sendEmptyMessage(4);
                        }
                    });
                    break;
                case 4:
                    System.out.println("ViplexCore Demo nvMakeProgramAsync(生成节目) begin... ");
                    instance.nvMakeProgramAsync(genrateProgram,new ViplexCore.CallBack() {

                        @Override
                        public void dataCallBack(int code, String data) {
                            Log.e("QHT: 生成节目:", data);
                            handler.sendEmptyMessage(5);
                        }
                    });
                    break;
                case 5:
                    System.out.println("ViplexCore Demo nvStartTransferProgramAsync(发送节目) begin... ");
                    instance.nvStartTransferProgramAsync(trasfromProgram,new ViplexCore.CallBack() {

                        @Override
                        public void dataCallBack(int code, String data) {
                            Log.e("QHT: 发送节目:", data);
                            //此处会不停的返回发送进度
                        }
                    });
                    break;
                case 6:
                    System.out.println("ViplexCore Demo nvGetProgramInfoAsync(获取节目信息) begin... ");
                    String requestDatasn = "{\"sn\":\"BZSA79353N1310006847\"}";
                    instance.nvGetProgramInfoAsync(requestDatasn,new ViplexCore.CallBack() {

                        @Override
                        public void dataCallBack(int code, String data) {
                            Log.e("QHT: 获取节目信息:", data);
                            handler.sendEmptyMessage(7);
                        }
                    });
                    break;
                case 7:
                    Log.e("QHT:", " END");
                    break;
            }
        }
    };
}

